function overall_CV
% 
% LICENSE CONDITIONS
% ==================================
% 
% Copyright   2011   The Regents of the University of California
% All Rights Reserved
% 
% Permission to use, copy, modify and distribute any part of this 
% code for designing classifiers for educational, research 
% and non-profit purposes, without fee, and without a written 
% agreement is hereby granted, provided that the above copyright 
% notice, this paragraph and the following three paragraphs appear 
% in all copies.
% 
% Those desiring to incorporate this code for TaylorBoost
% into commercial products or use for commercial purposes 
% should contact the Technology Transfer & Intellectual Property 
% Services, University of California, San Diego, 9500 Gilman Drive, 
% Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, 
% FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
% 
% IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE 
% TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
% OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, 
% ARISING OUT OF THE USE OF THIS CODE FOR TAYLORBOOST,  
% EVEN IF THE UNIVERSITY OF CALIFORNIA 
% HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% 
% THE CODE FOR TAYLORBOOST PROVIDED 
% HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF 
% CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
% SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  
% THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS 
% AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED 
% OR EXPRESS, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
% WARRANTIES OF MERCHANTABILITY OR FITNESS FOR 
% A PARTICULAR PURPOSE, OR THAT THE USE OF THE 
% CODE FOR DISCRIMINANT SALIENCY TRACKER WILL NOT 
% INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Please cite the following paper if you are using this code:
%   
%   TaylorBoost: First and Second Order Boosting Algorithms with Explicit Margin Control
%   Mohammad J. Saberian, Hamed Masnadi-Shirazi and Nuno Vasconcelos .
%   Proc. IEEE Conference on Computer Vision and Pattern Recognition (CVPR),
%   Colorado Springs, CO, 2011.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This is a matlab function that implements TaylorBoost for a toy data set 
% using regression weak learners. 
% 
% inputs: 
%
% Tf: number of iterations
% These variables are  in train_'S' and test_'S' files
% XF: is the training set where each row is one traingin example
% Y: is the label of examples
% XFv and Yv are the test sets
% f: is the feature matrix where i^th feature is Hi=XF*f(:,i);
% Type: select 'G' for gradient (First order) and 'N' for Newton method  (Second order) 
% L_Type: select the type of loss function 

Tf=500            

S='ng_synt'
loc=pwd;
load([loc '/test_' S]);
load([loc '/train_' S]);

f=eye(size(XF,2));



%%%%%%%%%%%%%%%%%% Select either Gradinet method of Newtorn method

Type='G';
% Type='N';

%%%%%%%%%%%%%%%%%% Select the loss function %%%%%%%%%%%%%%%%%

% L_Type='Exp';
L_Type='Log';
% L_Type='Lap';
% L_Type='CBL';

%%%%%%%%%%%%%%%%%%%%% load data %%%%%%%%%%%%%%%%%%%%%%%


step=1                            
C=0.5                             
Z=0.5;


%%%%%%%%%%%%%% Learning %%%%%%%%%%%%%
err_Lin=main_Lin(XF,Y,XFv,Yv,S,step,C,Z,Tf,1,f,Type,L_Type);

    